<template lang="pug">
    v-dialog(
        :value="show"
        @click:outside="$emit('hide')"
        persistent
    )
        v-card
            v-card-title New Photo
            v-card-text
                v-select(
                    :items="photoTypes"
                    v-model="photoType"
                    label="PhotoType"
                )
                v-text-field(
                    v-if="photoType === 3 || photoType === 4"
                    label="Roll"
                    v-model="roll"
                    type="number"
                )
                v-text-field(
                    label="frame"
                    v-model="frame"
                    type="number"
                )
                v-select(
                    label="Direction"
                    :items="orientations"
                    v-model="direction"
                )
                v-textarea(
                    label="Description"
                    v-model="description"
                )
                v-checkbox(
                    v-model="landscape"
                    label="Landscape"
                )
                v-text-field(
                    label="Camera"
                    v-model="camera"
                )
                v-file-input(
                    v-model="photo"
                    label="Flie"
                )
                v-btn(
                    @click="submit"
                ) Submit
</template>

<script>
import { mapGetters, mapActions } from "vuex";

export default {
    name: "photo-input",
    props: {
        show: {
            required: true,
            type: Boolean
        }
    },
    data() {
        return {
            photoType: null,
            roll: null,
            frame: null,
            direction: null,
            description: null,
            landscape: false,
            camera: null,
            photo: null
        };
    },
    mounted() {
        this.fetchAllPhoto({
            link: this.getATrench.data.relationships.photo
        }).then(response => {
            this.fetchPhotoType({ link: response.links.photoTypes });
            this.fetchOrientation({ link: response.links.orientations });
        });
    },
    computed: {
        ...mapGetters({
            getAProject: "project/getAProject",
            getASite: "site/getASite",
            getATrench: "trench/getATrench",
            getAllPhoto: "photo/getAllPhoto",
            getPhotoType: "photoType/getPhotoType",
            getOrientation: "orientation/getOrientation"
        }),
        photoTypes() {
            if (this.getPhotoType.data) {
                return this.getPhotoType.data.map(el => {
                    return {
                        text: el.attributes.photo_type,
                        value: el.id
                    };
                });
            } else {
                return [];
            }
        },
        orientations() {
            if (this.getOrientation.data) {
                return this.getOrientation.data.map(el => {
                    return {
                        text: el.attributes.orientation_direction,
                        value: el.id
                    };
                });
            } else {
                return [];
            }
        }
    },
    methods: {
        ...mapActions({
            fetchAllPhoto: "photo/fetchAllPhoto",
            fetchPhotoType: "photoType/fetchPhotoType",
            fetchOrientation: "orientation/fetchOrientation",
            createAPhoto: "photo/createAPhoto"
        }),
        submit() {
            const data = new FormData();
            data.append("photo_type", this.photoType);
            data.append("roll", this.roll);
            data.append("frame", this.frame);
            data.append("direction", this.direction);
            data.append("description", this.description);
            data.append("landscape", this.landscape);
            data.append("camera", this.camera);
            data.append("trench", this.getATrench.id);
            data.append("site", this.getASite.id);
            data.append("project", this.getAProject.id);
            data.append("photo", this.photo);
            this.createAPhoto({
                url: this.getAllPhoto.links.self,
                payload: data
            }).then(() => {
                this.$emit("hide");
            });
        }
    }
};
</script>
